#!/bin/bash

# This script will build your TASTE system.
# It is customized for the CORDET2 project

# CORDET2 configuration.
SOURCE_DIR=`pwd`/scm_examples/src/
USER_INCLUDES=



# CORDET2 on-board time
OB_TIME_SATELLITE_TIME=obtimesatellitetime

# CORDET2 ground configuration
GROUND_PACKET_SERVICE=groundpacketservice

# CORDET2 packet service configuration
PS_ETHERNET_PROXY=psethernetproxy
PS_ETHERNET_TX_TABLE=psethernettxtable 
PS_RX_DIPATCHING=psrxdispatching
PS_TX_MANAGEMENT=pstxmanagement
PS_RX_TABLE=psrxtable
PS_TM_ROUTING_TABLE=pstmroutingtable

# CORDET2 data handling core configuration
DHC_TC_DISPATCHER=dhctcdispatcher
DHC_TC_TABLES=dhctctables
DHC_TC_VERIFICATION=dhctcverification
DHC_TC_PUBLISHING=dhctcpublishing
DHC_TM_RECEIVER=dhctmreceiver

# CORDET2 reporting configuration
REPORTING_TM_PUBLISHING=reportingtmpublishing
REPORTING_TM_TABLE=reportingtmtable
REPORTING_TM_DISPATCHING=reportingtmdispatching
REPORTING_TM_GENERATE_TM=reportinggeneratetm
REPORTING_CONTROL_EVENT_REPORT=reportingcontroleventreport
REPORTING_EVENT_REPORT_GENERATION=reportingeventreportgeneration

# CORDET2 commanding configuration
COMMANDING_TC_PUBLISHING=commandingtcpublishing
COMMANDING_TC_TABLE=commandingtctable
COMMANDING_TC_DISPATCHER=commandingtcdispatcher
COMMANDING_PROCESS_COMMAND=commandingprocesscommand
COMMANDING_COMMAND_VERIFICATION_MANAGER=commandingcommandverificationmanager
COMMANDING_COMMAND_FUNCTIONALITY=commandingcommandfunctionality
COMMANDING_SYSTEM_MANAGEMENT=commandingsystemmanagement

# CORDET2 commanding configuration
MONITORING_TC_PUBLISHING=monitoringtcpublishing
MONITORING_TC_TABLE=monitoringtctable
MONITORING_TC_DISPATCHING=monitoringtcdispatching
MONITORING_PROCESS_COMMAND=monitoringprocesscommand
MONITORING_CONTROL=monitoringcontrol
MONITORING_MONITOR=monitoringmonitor
MONITORING_DATA_ACQUISITION=monitoringdataacquisition

# CORDET2 time management configuration
TIME_PROCESS_TC=timeprocesstc
TIME_REPORT_RATE=timereportrate

C_INCLUDE_PATH=$C_INCLUDE_PATH

# You must check it before running it: it may need to be adapted to your context:
# 1) You may need to fix some paths and filenames (path to interface/deployment views)
# 2) You may need to specify additional paths for the compiler to find .h file
#    (e.g. "export C_INCLUDE_PATH=/usr/include/xenomai/analogy/:$C_INCLUDE_PATH")
# 3) You may need to link with pre-built libraries, using the -l option
#    (e.g. -l /usr/lib/libanalogy.a,/usr/lib/librtdm.a)
# 4) You may need to change the runtime (add -p flag to select PolyORB-HI-C)
# etc.

# Note: TASTE will not overwrite your changes - if you need to update some  parts
#       you will have to merge the changes with the newly-created "build-script.new.sh" file.
rm -f $SOURCE_DIR/*.zip

# Zipping the source code as required by TASTE
cd $SOURCE_DIR; zip producer_inst.zip producer_inst/*; cd -;
cd $SOURCE_DIR; zip consumer_inst.zip consumer_inst/*; cd -;


cd $SOURCE_DIR; zip $PS_ETHERNET_PROXY.zip $PS_ETHERNET_PROXY/*; cd -;
cd $SOURCE_DIR; zip $PS_ETHERNET_TX_TABLE.zip $PS_ETHERNET_TX_TABLE/*; cd -;
cd $SOURCE_DIR; zip $PS_RX_DIPATCHING.zip $PS_RX_DIPATCHING/*; cd -;
cd $SOURCE_DIR; zip $PS_TX_MANAGEMENT.zip $PS_TX_MANAGEMENT/*; cd -;
cd $SOURCE_DIR; zip $PS_RX_TABLE.zip $PS_RX_TABLE/*; cd -;
cd $SOURCE_DIR; zip $PS_TM_ROUTING_TABLE.zip $PS_TM_ROUTING_TABLE/*; cd -;
cd $SOURCE_DIR; zip $GROUND_PACKET_SERVICE.zip $GROUND_PACKET_SERVICE/*; cd -;
cd $SOURCE_DIR; zip $DHC_TC_DISPATCHER.zip $DHC_TC_DISPATCHER/*; cd -;
cd $SOURCE_DIR; zip $DHC_TC_TABLES.zip $DHC_TC_TABLES/*; cd -;
cd $SOURCE_DIR; zip $DHC_TC_VERIFICATION.zip $DHC_TC_VERIFICATION/*; cd -;
cd $SOURCE_DIR; zip $DHC_TC_PUBLISHING.zip $DHC_TC_PUBLISHING/*; cd -;
cd $SOURCE_DIR; zip $DHC_TM_RECEIVER.zip $DHC_TM_RECEIVER/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_TM_PUBLISHING.zip $REPORTING_TM_PUBLISHING/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_TM_TABLE.zip $REPORTING_TM_TABLE/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_TM_DISPATCHING.zip $REPORTING_TM_DISPATCHING/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_TM_GENERATE_TM.zip $REPORTING_TM_GENERATE_TM/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_CONTROL_EVENT_REPORT.zip $REPORTING_CONTROL_EVENT_REPORT/*; cd -;
cd $SOURCE_DIR; zip $REPORTING_EVENT_REPORT_GENERATION.zip $REPORTING_EVENT_REPORT_GENERATION/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_TC_PUBLISHING.zip $COMMANDING_TC_PUBLISHING/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_TC_TABLE.zip $COMMANDING_TC_TABLE/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_TC_DISPATCHER.zip $COMMANDING_TC_DISPATCHER/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_PROCESS_COMMAND.zip $COMMANDING_PROCESS_COMMAND/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_COMMAND_VERIFICATION_MANAGER.zip $COMMANDING_COMMAND_VERIFICATION_MANAGER/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_COMMAND_FUNCTIONALITY.zip $COMMANDING_COMMAND_FUNCTIONALITY/*; cd -;
cd $SOURCE_DIR; zip $COMMANDING_SYSTEM_MANAGEMENT.zip $COMMANDING_SYSTEM_MANAGEMENT/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_TC_PUBLISHING.zip $MONITORING_TC_PUBLISHING/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_TC_TABLE.zip $MONITORING_TC_TABLE/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_TC_DISPATCHING.zip $MONITORING_TC_DISPATCHING/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_PROCESS_COMMAND.zip $MONITORING_PROCESS_COMMAND/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_CONTROL.zip $MONITORING_CONTROL/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_MONITOR.zip $MONITORING_MONITOR/*; cd -;
cd $SOURCE_DIR; zip $MONITORING_DATA_ACQUISITION.zip $MONITORING_DATA_ACQUISITION/*; cd -;
cd $SOURCE_DIR; zip $TIME_PROCESS_TC.zip $TIME_PROCESS_TC/*; cd -;
cd $SOURCE_DIR; zip $TIME_REPORT_RATE.zip $TIME_REPORT_RATE/*; cd -;
cd $SOURCE_DIR; zip $OB_TIME_SATELLITE_TIME.zip $OB_TIME_SATELLITE_TIME/*; cd -;

[ ! -z "$CLEANUP" ] && rm -rf binary
export CLEANUP=false

echo Building the system with the polyHI-Ada
assert-builder-ocarina.py \
	--fast \
	--aadlv2 \
	--keep-case \
	--interfaceView InterfaceView.aadl \
	--deploymentView DeploymentView.aadl \
   	-o $SOURCE_DIR/binary \
	--subC producer_inst:$SOURCE_DIR/producer_inst.zip \
	--subC consumer_inst:$SOURCE_DIR/consumer_inst.zip \
	--subAda psethernetproxy:$SOURCE_DIR/psethernetproxy.zip \
	--subAda psethernettxtable:$SOURCE_DIR/psethernettxtable.zip \
	--subAda psrxdispatching:$SOURCE_DIR/psrxdispatching.zip \
	--subAda pstxmanagement:$SOURCE_DIR/pstxmanagement.zip \
	--subAda psrxtable:$SOURCE_DIR/psrxtable.zip \
	--subAda pstmroutingtable:$SOURCE_DIR/pstmroutingtable.zip \
	--subAda groundpacketservice:$SOURCE_DIR/groundpacketservice.zip \
	--subAda dhctcdispatcher:$SOURCE_DIR/dhctcdispatcher.zip \
	--subAda dhctctables:$SOURCE_DIR/dhctctables.zip \
	--subAda dhctcverification:$SOURCE_DIR/dhctcverification.zip \
	--subAda dhctcpublishing:$SOURCE_DIR/dhctcpublishing.zip \
	--subAda dhctmreceiver:$SOURCE_DIR/dhctmreceiver.zip \
	--subAda reportingtmpublishing:$SOURCE_DIR/reportingtmpublishing.zip \
	--subAda reportingtmtable:$SOURCE_DIR/reportingtmtable.zip \
	--subAda reportingtmdispatching:$SOURCE_DIR/reportingtmdispatching.zip \
	--subAda reportinggeneratetm:$SOURCE_DIR/reportinggeneratetm.zip \
	--subAda reportingcontroleventreport:$SOURCE_DIR/reportingcontroleventreport.zip \
	--subAda reportingeventreportgeneration:$SOURCE_DIR/reportingeventreportgeneration.zip \
	--subAda commandingtcpublishing:$SOURCE_DIR/commandingtcpublishing.zip \
	--subAda commandingtctable:$SOURCE_DIR/commandingtctable.zip \
	--subAda commandingtcdispatcher:$SOURCE_DIR/commandingtcdispatcher.zip \
	--subAda commandingprocesscommand:$SOURCE_DIR/commandingprocesscommand.zip \
	--subAda commandingcommandverificationmanager:$SOURCE_DIR/commandingcommandverificationmanager.zip \
	--subAda commandingcommandfunctionality:$SOURCE_DIR/commandingcommandfunctionality.zip \
	--subAda commandingsystemmanagement:$SOURCE_DIR/commandingsystemmanagement.zip \
	--subAda monitoringtcpublishing:$SOURCE_DIR/monitoringtcpublishing.zip \
	--subAda monitoringtctable:$SOURCE_DIR/monitoringtctable.zip \
	--subAda monitoringtcdispatching:$SOURCE_DIR/monitoringtcdispatching.zip \
	--subAda monitoringprocesscommand:$SOURCE_DIR/monitoringprocesscommand.zip \
	--subAda monitoringcontrol:$SOURCE_DIR/monitoringcontrol.zip \
	--subAda monitoringmonitor:$SOURCE_DIR/monitoringmonitor.zip \
	--subAda monitoringdataacquisition:$SOURCE_DIR/monitoringdataacquisition.zip \
	--subAda timeprocesstc:$SOURCE_DIR/timeprocesstc.zip \
	--subAda timereportrate:$SOURCE_DIR/timereportrate.zip \
	--subAda obtimesatellitetime:$SOURCE_DIR/obtimesatellitetime.zip \

